#include "testApp.h"


//--------------------------------------------------------------
void testApp::setup(){	
	
	ofSetVerticalSync(true);
	ofEnableSmoothing();
	ofSetFrameRate(60);
	
	for (int i = 0; i < 50; i++){
		particle myParticle;
		
		float xorig = mouseX+i/2;
		float yorig = mouseY+i/2;
		float radius = 5+i*4;
		
		float iAngle = ofMap(i, 1, particles.size(), 0, 2.0*PI); 
		float angle = iAngle+ ofGetElapsedTimef()*2;
		
		float vx  = xorig + radius * cos(angle);
		float vy  = yorig + radius * -sin(angle);
		
		//particles[i].pos.x = xorig + radius * cos(angle);
		//particles[i].pos.y = yorig + radius * -sin(angle);
		
		//float vx = ofRandom(-4,4);
		//float vy = ofRandom(-4,4);
		
		myParticle.setInitialCondition(mouseX,mouseY,vx, vy);	
		// more interesting with diversity :)
		// uncomment this: 
		//myParticle.damping = ofRandom(0.01, 0.05);
		particles.push_back(myParticle);
	}
	
}

//--------------------------------------------------------------
void testApp::update(){

	// on every frame 
	// we reset the forces
	// add in any forces on the particle
	// perfom damping and
	// then update
	
	//float time = sin(ofGetElapsedTimef());
	
	for (int i = 0; i < particles.size(); i++){
		particles[i].resetForce();
		particles[i].addForce(0.0001,0.0001);  // gravity
		particles[i].bounceOffWalls();
		particles[i].addDampingForce();
		particles[i].update();
		
	} // end for

}

//--------------------------------------------------------------
void testApp::draw(){

// connecting points
/*	
	ofSetColor(10, 72, 125); 
	ofBeginShape();
	for (int i = 0; i < particles.size(); i++){
		//particles[i].draw();
		ofVertex(particles[i].pos.x, particles[i].pos.y);
	}
	ofEndShape(true);
*/	
	
// draw particles
	
	for (int i = 0; i < particles.size(); i++){
		particles[i].draw();
	}
	
}

//--------------------------------------------------------------
void testApp::keyPressed  (int key){ 
}

//--------------------------------------------------------------
void testApp::keyReleased  (int key){ 
}

//--------------------------------------------------------------
void testApp::mouseMoved(int x, int y ){
}

//--------------------------------------------------------------
void testApp::mouseDragged(int x, int y, int button){
}

//--------------------------------------------------------------
void testApp::mousePressed(int x, int y, int button){
	for (int i = 0; i < particles.size(); i++){
		
		float xorig = mouseX+i/2;
		float yorig = mouseY+i/2;
		
		float radius = 5+i*4;
		
		float iAngle = ofMap(i, 1, particles.size(), 0, 2.0*PI); 
		float angle = iAngle+ sin(ofGetElapsedTimef());//ofMap(sin(ofGetElapsedTimef()), -1, 1, 0, 2.0*PI)*2;
		
		float vx  = xorig + radius * cos(angle);
		float vy  = yorig + radius * -sin(angle);
		//float vx = ofRandom(-4,4);
		//float vy = ofRandom(-4,4);
		particles[i].setInitialCondition(mouseX,mouseY,vx, vy);	
	
	} // end for
}

//--------------------------------------------------------------
void testApp::mouseReleased(){
}
